%define anolis_release 5
# use nestnmp_check 0 to speed up packaging by disabling 'make test'
%{!?netsnmp_check: %global netsnmp_check 1}

# actual soname version
%global soname  40

Summary:    A collection of SNMP protocol tools and libraries
Name:       net-snmp
Version:    5.9.3
Release:    %{anolis_release}%{?dist}
Epoch:      1

License:    BSD
URL:        http://net-snmp.sourceforge.net/
Source0:    https://downloads.sourceforge.net/project/net-snmp/net-snmp/%{version}/net-snmp-%{version}.tar.gz
Source1:    net-snmp.conf
Source4:    net-snmp-trapd.conf
Source5:    net-snmpd.sysconfig
Source6:    net-snmptrapd.sysconfig
Source7:    net-snmp-tmpfs.conf
Source8:    snmpd.service
Source9:    snmptrapd.service
Source10:   IETF-MIB-LICENSE.txt

Patch1: 0001-net-snmp-5.9-pie.patch
Patch2: 0002-net-snmp-5.9-dir-fix.patch
Patch3: 0003-net-snmp-5.9-test-debug.patch
Patch4: 0004-net-snmp-5.7.2-cert-path.patch
Patch5: 0005-net-snmp-5.9-cflags.patch
Patch6: 0006-net-snmp-5.8-Remove-U64-typedef.patch
Patch7: 0007-net-snmp-5.7.3-iterator-fix.patch
Patch8: 0008-net-snmp-5.9-autofs-skip.patch
Patch9: 0009-net-snmp-5.9-coverity.patch
Patch10: 0010-net-snmp-5.8-expand-SNMPCONFPATH.patch
Patch11: 0011-net-snmp-5.8-duplicate-ipAddress.patch
Patch12: 0012-net-snmp-5.9-memory-reporting.patch
Patch13: 0013-net-snmp-5.8-man-page.patch
Patch14: 0014-net-snmp-5.8-ipAddress-faster-load.patch
Patch15: 0015-net-snmp-5.8-rpm-memory-leak.patch
Patch16: 0016-net-snmp-5.9-aes-config.patch
Patch17: 0017-net-snmp-5.8-clientaddr-error-message.patch
Patch18: 0018-net-snmp-5.9-intermediate-certs.patch
Patch19: 0019-net-snmp-5.9.1-remove-des.patch
Patch20: 0020-net-snmp-5.9.1-autoconf.patch
Patch21: 0021-net-snmp-libs-misunderstanding.patch

# Modern RPM API means
Patch101: 0101-net-snmp-5.8-modern-rpm-api.patch
#disable this patch due compatibility issues
Patch102: 0102-net-snmp-5.9-python3.patch

Patch200: CVE-2022-44792-and-44793.patch

Requires:        %{name}-libs = %{epoch}:%{version}-%{release}
Requires:        %{name}-agent-libs = %{epoch}:%{version}-%{release}
# This is actually needed for the %%triggerun script but Requires(triggerun)
# is not valid.  We can use %%post because this particular %%triggerun script
# should fire just after this package is installed.
%{?systemd_requires}
BuildRequires:   make
BuildRequires:   systemd
BuildRequires:   gcc
BuildRequires:   openssl-devel, bzip2-devel, elfutils-devel
BuildRequires:   libselinux-devel, elfutils-libelf-devel, rpm-devel
BuildRequires:   perl-devel, perl(ExtUtils::Embed), procps
BuildRequires:   python3-devel, python3-setuptools
BuildRequires:   chrpath
BuildRequires:   mariadb-connector-c-devel
# for netstat, needed by 'make test'
BuildRequires:   net-tools
# for make test
BuildRequires:   perl(:VERSION) >= 5.6
BuildRequires:   perl(AutoLoader)
BuildRequires:   perl(blib)
BuildRequires:   perl(Carp)
BuildRequires:   perl(DynaLoader)
BuildRequires:   perl(Exporter)
BuildRequires:   perl(overload)
BuildRequires:   perl(strict)
BuildRequires:   perl(TAP::Harness)
BuildRequires:   perl(vars)
BuildRequires:   perl(warnings)
BuildRequires:   lm_sensors-devel >= 3
BuildRequires:   autoconf, automake
BuildRequires:   python3-rpm-macros

%description
SNMP (Simple Network Management Protocol) is a protocol used for
network management. The NET-SNMP project includes various SNMP tools:
an extensible agent, an SNMP library, tools for requesting or setting
information from SNMP agents, tools for generating and handling SNMP
traps, a version of the netstat command which uses SNMP, and a Tk/Perl
mib browser. This package contains the snmpd and snmptrapd daemons,
documentation, etc.

You will probably also want to install the net-snmp-utils package,
which contains NET-SNMP utilities.

%package utils
Summary:  Network management utilities using SNMP, from the NET-SNMP project
Requires: %{name}-libs = %{epoch}:%{version}-%{release}

%description utils
The net-snmp-utils package contains various utilities for use with the
NET-SNMP network management project.

Install this package if you need utilities for managing your network
using the SNMP protocol. You will also need to install the net-snmp
package.

%package devel
Summary:  The development environment for the NET-SNMP project
Requires: %{name}-libs = %{epoch}:%{version}-%{release}
Requires: %{name}-agent-libs = %{epoch}:%{version}-%{release}
Requires: elfutils-devel, rpm-devel, elfutils-libelf-devel, openssl-devel
Requires: system-rpm-config
Requires: lm_sensors-devel
# pull perl development libraries, net-snmp agent libraries may link to them
Requires: perl-devel

%description devel
The net-snmp-devel package contains the development libraries and
header files for use with the NET-SNMP project's network management
tools.

Install the net-snmp-devel package if you would like to develop
applications for use with the NET-SNMP project's network management
tools. You'll also need to have the net-snmp and net-snmp-utils
packages installed.

%package perl
Summary:       The perl NET-SNMP module and the mib2c tool
Requires:      %{name}-libs = %{epoch}:%{version}-%{release}, perl-interpreter
Requires:      %{name}-agent-libs = %{epoch}:%{version}-%{release}
Requires:      %{name}-devel = %{epoch}:%{version}-%{release}
BuildRequires: perl-interpreter
BuildRequires: perl-generators

%description perl
The net-snmp-perl package contains the perl files to use SNMP from within
Perl.

Install the net-snmp-perl package, if you want to use mib2c or SNMP 
with perl.

%package gui
Summary:  An interactive graphical MIB browser for SNMP
Requires: perl-Tk, net-snmp-perl = %{epoch}:%{version}-%{release}

%description gui
The net-snmp-gui package contains tkmib utility, which is a graphical user 
interface for browsing the Message Information Bases (MIBs). It is also 
capable of sending or retrieving the SNMP management information to/from 
the remote agents interactively.

Install the net-snmp-gui package, if you want to use this interactive utility.

%package libs
Summary: The NET-SNMP runtime client libraries

%description libs
The net-snmp-libs package contains the runtime client libraries for shared
binaries and applications.

%package agent-libs
Summary:   The NET-SNMP runtime agent libraries
Requires:  %{name}-libs = %{epoch}:%{version}-%{release}

%description agent-libs
The net-snmp-agent-libs package contains the runtime agent libraries for shared
binaries and applications.

%package -n python3-net-snmp
%{?python_provide:%python_provide python3-net-snmp}
# Remove before F30
Provides:  %{name}-python = %{version}-%{release}
Obsoletes: %{name}-python < %{version}-%{release}
Summary:   The Python 'netsnmp' module for the Net-SNMP
Requires:  %{name}-libs = %{epoch}:%{version}-%{release}

%description -n python3-net-snmp
The 'netsnmp' module provides a full featured, tri-lingual SNMP (SNMPv3, 
SNMPv2c, SNMPv1) client API. The 'netsnmp' module internals rely on the
Net-SNMP toolkit library.

%prep
%autosetup -p1
cp %{SOURCE10} .

# disable failing test
rm testing/fulltests/default/T200*

%build

# Autoreconf to get autoconf 2.69 for ARM (#926223)
autoreconf

MIBS="host agentx smux \
     ucd-snmp/diskio tcp-mib udp-mib mibII/mta_sendmail \
     ip-mib/ipv4InterfaceTable ip-mib/ipv6InterfaceTable \
     ip-mib/ipAddressPrefixTable/ipAddressPrefixTable \
     ip-mib/ipDefaultRouterTable/ipDefaultRouterTable \
     ip-mib/ipv6ScopeZoneIndexTable ip-mib/ipIfStatsTable \
     sctp-mib rmon-mib etherlike-mib"

MIBS="$MIBS ucd-snmp/lmsensorsMib"

%configure \
    --disable-static --enable-shared \
    --enable-as-needed \
    --enable-blumenthal-aes \
    --enable-embedded-perl \
    --enable-ipv6 \
    --enable-local-smux \
    --enable-mfd-rewrites \
    --enable-ucd-snmp-compatibility \
    --disable-des \
    --sysconfdir=%{_sysconfdir} \
    --with-cflags="$RPM_OPT_FLAGS -fPIE" \
    --with-ldflags="$RPM_LD_FLAGS -lm" \
    --with-logfile="/var/log/snmpd.log" \
    --with-mib-modules="$MIBS" \
    --with-mysql \
    --with-openssl \
    --with-persistent-directory="/var/lib/net-snmp" \
    --with-perl-modules="INSTALLDIRS=vendor" \
    --with-pic \
    --with-security-modules=tsm  \
    --with-sys-location="Unknown" \
    --with-systemd \
    --with-temp-file-pattern=/run/net-snmp/snmp-tmp-XXXXXX \
    --with-transports="DTLSUDP TLSTCP" \
    --with-sys-contact="root@localhost" \
    --without-pcre <<EOF
EOF

# the package is not %%_smp_mflags safe
%{__make}

# remove rpath from compiled perl libs
find perl/blib -type f -name "*.so" -print -exec chrpath --delete {} \;

# compile python module
pushd python
%{__python3} setup.py --basedir="../" build
popd


%install
make install DESTDIR=%{buildroot}
# Determine which arch net-snmp-config.h is going to try to #include.
basearch=%{_arch}

install -d %{buildroot}%{_sysconfdir}/snmp
install -m 644 %SOURCE1 %{buildroot}%{_sysconfdir}/snmp/snmpd.conf
install -m 644 %SOURCE4 %{buildroot}%{_sysconfdir}/snmp/snmptrapd.conf

install -d %{buildroot}%{_sysconfdir}/sysconfig
install -m 644 %SOURCE5 %{buildroot}%{_sysconfdir}/sysconfig/snmpd
install -m 644 %SOURCE6 %{buildroot}%{_sysconfdir}/sysconfig/snmptrapd

# prepare /var/lib/net-snmp
install -d %{buildroot}%{_localstatedir}/lib/net-snmp
install -d %{buildroot}%{_localstatedir}/lib/net-snmp/mib_indexes
install -d %{buildroot}%{_localstatedir}/lib/net-snmp/cert_indexes
install -d %{buildroot}%{_localstatedir}/run/net-snmp

# remove things we don't want to distribute
rm -f %{buildroot}%{_bindir}/snmpinform
ln -s snmptrap %{buildroot}/usr/bin/snmpinform
rm -f %{buildroot}%{_bindir}/snmpcheck
rm -f %{buildroot}/%{_bindir}/fixproc
rm -f %{buildroot}/%{_mandir}/man1/fixproc*
rm -f %{buildroot}/%{_bindir}/ipf-mod.pl
rm -f %{buildroot}/%{_libdir}/libsnmp*

# remove special perl files
find %{buildroot} -name perllocal.pod \
    -o -name .packlist \
    -o -name "*.bs" \
    -o -name Makefile.subs.pl \
    | xargs -ri rm -f {}
# remove docs that do not apply to Linux
rm -f README.aix README.hpux11 README.osX README.Panasonic_AM3X.txt README.solaris README.win32

# copy missing mib2c.conf files
install -m 644 local/mib2c.*.conf %{buildroot}%{_datadir}/snmp

# install python module
pushd python
%{__python3} setup.py --basedir=.. install -O1 --skip-build --root %{buildroot} 
popd

find %{buildroot} -name '*.so' | xargs chmod 0755

# trim down massive ChangeLog
dd bs=1024 count=250 if=ChangeLog of=ChangeLog.trimmed

# convert files to UTF-8
for file in README COPYING; do
    iconv -f 8859_1 -t UTF-8 <$file >$file.utf8
    mv $file.utf8 $file
done

# remove executable bit from documentation samples
chmod 644 local/passtest local/ipf-mod.pl

# systemd stuff
install -m 755 -d %{buildroot}/%{_tmpfilesdir}
install -m 644 %SOURCE7 %{buildroot}/%{_tmpfilesdir}/net-snmp.conf
install -m 755 -d %{buildroot}/%{_unitdir}
install -m 644 %SOURCE8 %SOURCE9 %{buildroot}/%{_unitdir}/

%generate_compatibility_deps
rm -f %{buildroot}/%{abidir}/.mib2c-updaterc

%check
%if %{netsnmp_check}
# temporary workaround to make test "extending agent functionality with pass" working
chmod 755 local/passtest

LD_LIBRARY_PATH=%{buildroot}/%{_libdir} make test

%endif


%post
%systemd_post snmpd.service snmptrapd.service

%preun
%systemd_preun snmpd.service snmptrapd.service


%postun
%systemd_postun_with_restart snmpd.service snmptrapd.service

%files
%license COPYING IETF-MIB-LICENSE.txt
%doc ChangeLog.trimmed EXAMPLE.conf FAQ NEWS TODO
%doc README README.agent-mibs README.agentx README.krb5 README.snmpv3
%doc local/passtest local/ipf-mod.pl
%doc README.thread AGENT.txt PORTING local/README.mib2c
%dir %{_sysconfdir}/snmp
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/snmp/snmpd.conf
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/snmp/snmptrapd.conf
%{_bindir}/snmpconf
%{_bindir}/net-snmp-create-v3-user
%{_sbindir}/*
%{abidir}/*-option.list
%attr(0644,root,root) %{_mandir}/man[58]/snmp*d*
%attr(0644,root,root) %{_mandir}/man5/snmp_config.5*
%attr(0644,root,root) %{_mandir}/man5/variables*
%attr(0644,root,root) %{_mandir}/man1/net-snmp-create-v3-user*
%attr(0644,root,root) %{_mandir}/man1/snmpconf.1*
%dir %{_datadir}/snmp
%{_datadir}/snmp/snmpconf-data
%dir %{_localstatedir}/run/net-snmp
%{_tmpfilesdir}/net-snmp.conf
%{_unitdir}/snmp*
%config(noreplace) %{_sysconfdir}/sysconfig/snmpd
%config(noreplace) %{_sysconfdir}/sysconfig/snmptrapd
%{_bindir}/agentxtrap
%attr(0644,root,root) %{_mandir}/man1/agentxtrap.1*

%files utils
%{_bindir}/encode_keychange
%{_bindir}/snmp[^c-]*
%attr(0644,root,root) %{_mandir}/man1/snmp[^-]*.1*
%attr(0644,root,root) %{_mandir}/man1/encode_keychange*.1*
%attr(0644,root,root) %{_mandir}/man5/snmp.conf.5*
%attr(0644,root,root) %{_mandir}/man5/variables.5*

%files devel
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*
%{_includedir}/*
%attr(0644,root,root) %{_mandir}/man3/*.3.*
%attr(0755,root,root) %{_bindir}/net-snmp-config*
%attr(0644,root,root) %{_mandir}/man1/net-snmp-config*.1.*

%files perl
%{_bindir}/mib2c-update
%{_bindir}/mib2c
%{_bindir}/snmp-bridge-mib
%{_bindir}/net-snmp-cert
%{_bindir}/checkbandwidth
%dir %{_datadir}/snmp
%{_datadir}/snmp/mib2c*
%{_datadir}/snmp/*.pl
%{_bindir}/traptoemail
%attr(0644,root,root) %{_mandir}/man[15]/mib2c*
%attr(0644,root,root) %{_mandir}/man3/*.3pm.*
%attr(0644,root,root) %{_mandir}/man1/traptoemail*.1*
%attr(0644,root,root) %{_mandir}/man1/snmp-bridge-mib.1*
%{perl_vendorarch}/*SNMP*
%{perl_vendorarch}/auto/*SNMP*
%{perl_vendorarch}/Bundle/MakefileSubs.pm
%{abidir}/ASN.dump
%{abidir}/OID.dump
%{abidir}/SNMP.dump
%{abidir}/TrapReceiver.dump
%{abidir}/agent.dump
%{abidir}/default_store.dump

%files -n python3-net-snmp
%doc README
%{python3_sitearch}/*
%{abidir}/client_intf.cpython-%{python3_version_nodots}-%{_arch}-linux-gnu.dump

%files gui
%{_bindir}/tkmib
%attr(0644,root,root) %{_mandir}/man1/tkmib.1*

%files libs
%dir %{abidir}
%license COPYING IETF-MIB-LICENSE.txt
%doc README ChangeLog.trimmed FAQ NEWS TODO
%{_libdir}/libnetsnmp.so.%{soname}*
%{abidir}/libnetsnmp.dump
%dir %{_datadir}/snmp
%dir %{_datadir}/snmp/mibs
%{_datadir}/snmp/mibs/*
%dir %{_localstatedir}/lib/net-snmp
%dir %{_localstatedir}/lib/net-snmp/mib_indexes
%dir %{_localstatedir}/lib/net-snmp/cert_indexes

%files agent-libs
%{_libdir}/libnetsnmpagent*.so.%{soname}*
%{_libdir}/libnetsnmphelpers*.so.%{soname}*
%{_libdir}/libnetsnmpmibs*.so.%{soname}*
%{_libdir}/libnetsnmptrapd*.so.%{soname}*
%{abidir}/libnetsnmpagent*.dump
%{abidir}/libnetsnmphelpers*.dump
%{abidir}/libnetsnmpmibs*.dump
%{abidir}/libnetsnmptrapd*.dump

%changelog
* Wed Mar 20 2024 Bo Ren <rb01097748@alibaba-inc.com> - 5.9.3-5
- Rebuild with python3.11

* Tue Mar 28 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:5.9.3-4
- Del Specific Fields

* Tue Jan 31 2023 Funda Wang <fundawang@yeah.net> - 1:5.9.3-3
- Add patches for CVE-2022-44792 and CVE-2022-44793 (from debian)

* Wed Nov 02 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:5.9.3-2
- optimise spec file 

* Fri Jul 29 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:5.9.3-1
- init from upstream
